# This is a dictionary setup file for FutureSQL
#    Last change: PFB 2001-09-04 14:47:51
#############################################################################
# See the file 'fsql_setup.pl' for documentation.
#############################################################################
# field_setup
sub field_setup
{

%dictionary = (

'table_name' => 'authors',

'key_field'   => 'a_id',

'field_order' => '
                  a_id,
                  a_category,
                  a_tags,
                  a_tag_labels,
                  first_name,
                  last_name,
                  user,
                  comments,
                  record_created,
                  record_updated
                 ',

'user_field_order' => '
                  a_id,
                  first_name,
                  last_name,
                  a_category,
                  user,
                  record_created,
                  record_updated
                 ',

'search_fields' => '
                  a_id,
                  a_category,
                  a_tags,
                  a_tag_labels,
                  first_name,
                  last_name,
                  user,
                  comments,
                  record_created,
                  record_updated
                 ',

'fields'      => {

                   'a_id' => {
                                   'label'             => 'A Id',
                                   'type'              => 'int(10) unsigned',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          # we don't try to process
                                                          # a value, since the value
                                                          # is created after this, at
                                                          # insert time, since this
                                                          # is an auto-increment field
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'a_category' => {
                                   'label'             => 'Category',
                                   'type'              => 'varchar',
                                   'html_type'         => 'popup_menu',
                                   'html_size'         => '50',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@a_category_array);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%a_category_hash);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'a_tags' => {
                                   'label'             => 'Tags',
                                   'type'              => 'text',
                                   'html_type'         => 'scrolling_list',
                                   'html_size'         => 'cols="15" rows="2"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(', ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(', ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@a_tags_array);
                                                                         },
                                                           'default'  => sub {
                                                                         # my ($string) = $field_value;
                                                                         my ($array_ref) = &convert_to_array('\, ');

                                                                         return($array_ref);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%a_tags_hash);
                                                                         },
                                                           'size'     => '3',
                                                           'multiple' => 'true',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'a_tag_labels' => {
                                   'label'             => 'Tag Labels',
                                   'type'              => 'text',
                                   'html_type'         => 'textarea',
                                   'html_size'         => 'cols="57" rows="3"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },


                   'first_name' => {
                                   'label'             => 'First Name',
                                   'type'              => 'varchar(50)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'last_name' => {
                                   'label'             => 'Last Name',
                                   'type'              => 'varchar(50)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'user' => {
                                   'label'             => 'User',
                                   'type'              => 'varchar(16)',
                                   'html_type'         => 'text',
                                   'html_size'         => '16',
                                   'max_length'        => '16',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'comments' => {
                                   'label'             => 'Comments',
                                   'type'              => 'text',
                                   'html_type'         => 'textarea',
                                   'html_size'         => 'cols="57" rows="3"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_created' => {
                                   'label'             => 'Record Created',
                                   'type'              => 'date',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');
                                                          $string = &get_date;
                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_updated' => {
                                   'label'             => 'Record Updated',
                                   'type'              => 'timestamp(14)',
                                   'html_type'         => 'text',
                                   'html_size'         => '14',
                                   'max_length'        => '14',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                 },

);

}
#############################################################################

1;