# This is a dictionary setup file for FutureSQL
#    Last change: PFB 2001-09-04 14:48:02
#############################################################################
# See the file 'fsql_setup.pl' for documentation.
#############################################################################
# field_setup
sub field_setup
{

%dictionary = (

'table_name' => 'books',

'key_field'   => 'b_id',

'field_order' => '
                  b_id,
                  a_id,
                  r_id,
                  book_title,
                  book_description,
                  book_rating,
                  book_rating_label,
                  reader_comments,
                  record_created,
                  record_updated
                 ',

'user_field_order' => '
                  b_id,
                  a_id,
                  r_id,
                  book_title,
                  book_description,
                  book_rating,
                  reader_comments,
                  record_created,
                  record_updated
                 ',

'search_fields' => '
                  b_id,
                  a_id,
                  r_id,
                  book_title,
                  book_description,
                  book_rating,
                  book_rating_label,
                  reader_comments,
                  record_created,
                  record_updated
                 ',

'fields'      => {

                   'b_id' => {
                                   'label'             => 'B Id',
                                   'type'              => 'int(10) unsigned',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          # we don't try to process
                                                          # a value, since the value
                                                          # is created after this, at
                                                          # insert time, since this
                                                          # is an auto-increment field
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'a_id' => {
                                   'label'             => 'A Id',
                                   'type'              => 'int(10) unsigned',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'r_id' => {
                                   'label'             => 'R Id',
                                   'type'              => 'int(10) unsigned',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'book_title' => {
                                   'label'             => 'Book Title',
                                   'type'              => 'varchar(100)',
                                   'html_type'         => 'text',
                                   'html_size'         => '55',
                                   'max_length'        => '100',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'book_description' => {
                                   'label'             => 'Book Description',
                                   'type'              => 'text',
                                   'html_type'         => 'textarea',
                                   'html_size'         => 'cols="55" rows="3"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'book_rating' => {
                                   'label'             => 'Book Rating',
                                   'type'              => 'varchar(1)',
                                   'html_type'         => 'popup_menu',
                                   'html_size'         => '1',
                                   'max_length'        => '1',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@book_rating_array);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%book_rating_hash);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'book_rating_label' => {
                                   'label'             => 'Book Rating Label',
                                   'type'              => 'varchar(100)',
                                   'html_type'         => 'text',
                                   'html_size'         => '40',
                                   'max_length'        => '100',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },


                   'reader_comments' => {
                                   'label'             => 'Reader Comments',
                                   'type'              => 'text',
                                   'html_type'         => 'textarea',
                                   'html_size'         => 'cols="55" rows="3"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_created' => {
                                   'label'             => 'Record Created',
                                   'type'              => 'date',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');
                                                          $string = &get_date;
                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_updated' => {
                                   'label'             => 'Record Updated',
                                   'type'              => 'timestamp(14)',
                                   'html_type'         => 'text',
                                   'html_size'         => '14',
                                   'max_length'        => '14',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                 },

);

}
#############################################################################

1;