# This is a dictionary setup file for FutureSQL
#    Last change: PFB 2001-09-04 14:48:15
#############################################################################
# See the file 'fsql_setup.pl' for documentation.
#############################################################################
# field_setup
sub field_setup
{

%dictionary = (

'table_name' => 'readers',

'key_field'   => 'r_id',

'field_order' => '
                  r_id,
                  user_type,
                  first_name,
                  last_name,
                  user,
                  password,
                  status,
                  city,
                  state,
                  work_phone,
                  work_email,
                  comments,
                  record_created,
                  record_updated
                 ',

'user_field_order' => '
                  r_id,
                  user_type,
                  first_name,
                  last_name,
                  user,
                  password,
                  status
                 ',

'search_fields' => '
                  r_id,
                  user_type,
                  first_name,
                  last_name,
                  user,
                  password,
                  status,
                  city,
                  state,
                  work_phone,
                  work_email,
                  comments,
                  record_created,
                  record_updated
                 ',

'fields'      => {

                   'r_id' => {
                                   'label'             => 'R Id',
                                   'type'              => 'int(10) unsigned',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          # we don't try to process
                                                          # a value, since the value
                                                          # is created after this, at
                                                          # insert time, since this
                                                          # is an auto-increment field
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'user_type' => {
                                   'label'             => 'User Type',
                                   'type'              => 'varchar(50)',
                                   'html_type'         => 'popup_menu',
                                   'html_size'         => '30',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@user_type_array);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%user_type_hash);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'first_name' => {
                                   'label'             => 'First Name',
                                   'type'              => 'varchar(50)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'last_name' => {
                                   'label'             => 'Last Name',
                                   'type'              => 'varchar(50)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '50',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'user' => {
                                   'label'             => 'User',
                                   'type'              => 'varchar(16)',
                                   'html_type'         => 'text',
                                   'html_size'         => '16',
                                   'max_length'        => '16',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'password' => {
                                   'label'             => 'Password',
                                   'type'              => 'varchar(16)',
                                   'html_type'         => 'text',
                                   'html_size'         => '16',
                                   'max_length'        => '16',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'status' => {
                                   'label'             => 'Status',
                                   'type'              => 'varchar(20)',
                                   'html_type'         => 'popup_menu',
                                   'html_size'         => '20',
                                   'max_length'        => '20',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@user_status_array);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%user_status_hash);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'city' => {
                                   'label'             => 'City',
                                   'type'              => 'varchar(100)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '100',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'state' => {
                                   'label'             => 'State',
                                   'type'              => 'char(2)',
                                   'html_type'         => 'popup_menu',
                                   'html_size'         => '2',
                                   'max_length'        => '2',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return(\@state_array);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return(\%state_hash);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'work_phone' => {
                                   'label'             => 'Work Phone',
                                   'type'              => 'varchar(100)',
                                   'html_type'         => 'text',
                                   'html_size'         => '20',
                                   'max_length'        => '100',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'work_email' => {
                                   'label'             => 'Work Email',
                                   'type'              => 'varchar(100)',
                                   'html_type'         => 'text',
                                   'html_size'         => '55',
                                   'max_length'        => '100',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'comments' => {
                                   'label'             => 'Comments',
                                   'type'              => 'text',
                                   'html_type'         => 'textarea',
                                   'html_size'         => 'cols="55" rows="3"',
                                   'max_length'        => '65535',
                                   'display_only'      => 'no',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_created' => {
                                   'label'             => 'Record Created',
                                   'type'              => 'date',
                                   'html_type'         => 'text',
                                   'html_size'         => '10',
                                   'max_length'        => '10',
                                   'display_only'      => 'yes_but_process',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');
                                                          $string = &get_date;
                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                   'record_updated' => {
                                   'label'             => 'Record Updated',
                                   'type'              => 'timestamp(14)',
                                   'html_type'         => 'text',
                                   'html_size'         => '14',
                                   'max_length'        => '14',
                                   'display_only'      => 'yes',
                                   'insert_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'update_expression' => sub {
                                                          my ($string) = &join_array(' ');

                                                          return($string);
                                                          },

                                   'default_value'     => sub {
                                                          my ($string) = '';

                                                          return($string);
                                                          },

                                   'display_process'   => 'none',
                                   'field_setup'       =>  {
                                                           'values'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'default'  => sub {
                                                                         my ($string) = $field_value;

                                                                         return($string);
                                                                         },
                                                           'labels'   => sub {
                                                                         my ($string) = '';

                                                                         return($string);
                                                                         },
                                                           'size'     => '',
                                                           'multiple' => '',
                                                           'linebreak'=> ''
                                                          },
                                   },

                 },

);

}
#############################################################################

1;