# This is the User Subroutine file for FutureSQL
#    Last change: PFB 2001-09-04 14:53:54
#############################################################################
# This file is for user defined variables and subroutines

################################################################################
# VARIABLES SECTION
################################################################################

# $my_var = 'something';



################################################################################
# SUBROUTINE SECTION
################################################################################
# my_subroutine
# sub my_subroutine
# {

# ...

# }
################################################################################
# update_table
sub update_table
{

# this is a SAMPLE function
#............................................................

# this subroutine is sample code that can be run in the 'post_op'
# section of the 'update_record' and 'save new record' action spec
# sections of the spec file. This allows things like lookup functions
# to do post processing of records, after the user hits save.

# this example was from a popup_menu in a group_id field, that was
# created from a foreign table call. Then, this function grabs the
# group_id, and gets the rest of the data from the foreign table,
# and saves it in the record. (this isn't relationally kosher, but
# it helps to have an additional field like 'group_name', for sorting.

my $sth_s = $dbh->prepare("select group_name
                           from groups where
                           group_id = $field_values{group_id}")
                           or die "Can't do select: $DBI::errstr\n";

my $rv_s = $sth_s->execute or die "Can't execute the query: $DBI::errstr\n";
( $group_name ) = $sth_s->fetchrow_array;

my $update_str = qq~update $table_name
                  set
                  group_name = '$group_name'
                  where $key_field = $field_values{$key_field}~;

my $sth = $dbh->do("$update_str")
                or die
                &error_message(qq~Error!<p>
                Can't save data: $DBI::errstr~);

}
#################################################################################
### routines used in the "Books / Authors" Demo
#################################################################################
# check_edit_authorization
sub check_edit_authorization
{

my $user;

if ( $w_user eq 'books_admin' ){return;}

if ( $table_name eq 'authors' or $table_name eq 'readers' )
        {
        ( $user ) = $dbh->selectrow_array(
                    "select user from $table_name
                     where $key_field = '$w_' ");

        unless ( $user eq $w_user )
                 {&error_message(qq~Error!<p>
                 Since this is not your record, you can't edit it.
                 <p>
                 You are user <b>[$w_user\]</b>. This record belongs
                 to <b>[$user\]</b>.
                 ~);}
        }
elsif ( $table_name eq 'books' )
        {
        ( $r_id ) = $dbh->selectrow_array(
                    "select r_id from books
                     where b_id = '$w_' ");

        unless ( $r_id )
                 {&error_message(qq~Error!<p>
                  Missing Reader ID in Book Record.
                 ~);}

        ( $user ) = $dbh->selectrow_array(
                    "select user from readers
                     where r_id = '$r_id' ");

        unless ( $user eq $w_user )
                 {&error_message(qq~Error!<p>
                 Since this is not your record, you can't edit it.
                 <p>
                 You are user <b>[$w_user\]</b>. This record belongs
                 to <b>[$user\]</b>.
                 ~);}
        }
else
        {return;}

}
#################################################################################
# update_books_table
sub update_books_table
{

$b_id = $field_values{'b_id'};

$book_rating       = $field_values{'book_rating'};
$book_rating_label = &get_code_titles(', ', $book_rating, \%book_rating_hash);

if ( $a_ eq 'save_new_record' )
        {
        ( $r_id ) =
                $dbh->selectrow_array(
                                      "select r_id
                                      from readers
                                      where user = '$w_user'
                                      "
                                      );

        unless ( $r_id ){&error_message(qq~Error!<p>
                            Reader record not found.~);}
        }
else
        {
        $r_id = $field_values{'r_id'};
        }

# update database fields

my $update_str = "update books set " .
                 "r_id              = " . $dbh->quote($r_id)              . ", " .
                 "book_rating_label = " . $dbh->quote($book_rating_label) . " "  .
                 "where b_id = '$b_id'";

my $sth = $dbh->do("$update_str")
                or die
                &error_message(qq~Error!<p>
                Can't update data: $DBI::errstr~);

}
################################################################################
# update_book_author
sub update_book_author
{

$b_id = $w_;
$a_id = param('a_id');

# update database fields

my $update_str = "update books set " .
                 "a_id              = " . $dbh->quote($a_id)              . " " .
                 "where b_id = '$b_id'";

my $sth = $dbh->do("$update_str")
                or die
                &error_message(qq~Error!<p>
                Can't update data: $DBI::errstr~);

}
################################################################################
# author_select
sub author_select
{

my $response_text;

$response_text = qq~
<b>Author Selection Screen</b>
<p>
~;

$b_b_id = $w_;
if ( $b_b_id < 1 ){$b_b_id = 0;}

$author_select_mode = param('author_select_mode');

if ( $author_select_mode eq 'edit' )
        {
        ( $a_current_a_id ) =
        $dbh->selectrow_array("select
                               a_id
                               from books
                               where b_id = '$b_b_id'
                              ");

        unless ( $a_current_a_id )
                 {&error_message(qq~Error!<p>Author ID Not found.~);}

        ( $a_first_name, $a_last_name ) =
        $dbh->selectrow_array("select
                               first_name, last_name
                               from authors
                               where a_id = '$a_current_a_id'
                              ");

        unless ( $a_last_name )
                 {&error_message(qq~Error!<p>Author Name Not found.~);}

        $response_text .= qq~
        <font size=-1>
        The current author assigned to book # $b_b_id is:<br>
        (A_ID $a_current_a_id\) $a_first_name $a_last_name
        <p>
        </font>
        ~;

        }

$response_text .= qq~
In order to enter in a new book, you have to select the author
first.<br>
So... please type in the last name of the Author that you
are searching for, and hit the find button.<br>
Note that you can type in a partial name, or even one letter.
</font>
~;

#... create search form

$response_text .= qq~
<FORM method="post" action="$script_name">
<input type="hidden" name="author_select_mode" value="$author_select_mode">
<input type="hidden" name="a_current_a_id"     value="$a_current_a_id">
<input type="hidden" name="a_first_name"       value="$a_first_name">
<input type="hidden" name="a_last_name"        value="$a_last_name">
<input type="hidden" name="b_b_id"             value="$b_b_id">

$security_fields

Last Name: <input type="text" name="last_name" size="30" maxlength="50">
<p>
<input type="hidden" name="s_"                 value="a.1">
<input type="hidden" name="dc_"                value="a.1">
<input type="hidden" name="r_"                 value="$default_rows_per_page">
<input type="hidden" name="p_"                 value="$p_">
<input type="hidden" name="rt_"                value="$rt_">
<input type="hidden" name="w_"                 value="1">
<input type="hidden" name="qbf"                value="yes">
<input type="hidden" name="a_"                 value="view_custom_list_._author">
<input type="hidden" name="show_select_params" value="no">
<input type="hidden" name="select_param"       value="like">
<input type="hidden" name="show_sort_params"   value="no">
<input type="hidden" name="sort_order"         value="last_name, first_name">
<input type="image" src="$image_url/find.gif"  border=0 alt="Find" name="Find">
</form>
<hr>
... or ... Display all Authors if you're not sure of the name.
<p>
<FORM method="post" action="$script_name">
<input type="hidden" name="author_select_mode" value="$author_select_mode">
<input type="hidden" name="a_current_a_id"     value="$a_current_a_id">
<input type="hidden" name="a_first_name"       value="$a_first_name">
<input type="hidden" name="a_last_name"        value="$a_last_name">
<input type="hidden" name="b_b_id"             value="$b_b_id">
$security_fields
<input type="hidden" name="wh_"                value="a_id > 0">
<input type="hidden" name="or_"                value="last_name, first_name">
<input type="hidden" name="custom_list_header" value="<b>All Records</b>, <i>Sorted by Last Name, First Name</i>">
<input type="hidden" name="s_"                 value="a.1">
<input type="hidden" name="dc_"                value="a.1">
<input type="hidden" name="r_"                 value="$default_rows_per_page">
<input type="hidden" name="p_"                 value="$p_">
<input type="hidden" name="rt_"                value="$rt_">
<input type="hidden" name="w_"                 value="1">
<input type="hidden" name="qbf"                value="no">
<input type="hidden" name="a_"                 value="view_custom_list_._author">
<input type="hidden" name="show_select_params" value="no">
<input type="hidden" name="select_param"       value="like">
<input type="hidden" name="show_sort_params"   value="no">
<input type="hidden" name="sort_order"         value="last_name, first_name">
<input type="image" src="$image_url/find.gif"  border=0 alt="Find" name="Find">
</form>
<p>
... or ... Click here to Add an Author
<br>
~;

&print_message($response_text);

}
################################################################################
# update_authors_table
sub update_authors_table
{

$a_id         = $field_values{'a_id'};
$a_tags       = $field_values{'a_tags'};
$a_tag_labels = &get_code_titles(', ', $a_tags, \%a_tags_hash);

# update database fields

my $update_str = "update authors set " .
                 "user         = " . $dbh->quote($w_user) . ", " .
                 "a_tag_labels = " . $dbh->quote($a_tag_labels) . " " .
                 "where a_id   = '$a_id'";

my $sth = $dbh->do("$update_str")
                or die
                &error_message(qq~Error!<p>
                Can't update data: $DBI::errstr~);

}
#################################################################################

1;
