# custom.authors.view_list.author.pl
#    Last change:  PFB  18 Feb 2001   10:55 pm
#############################################################################
# This is a custom view list spec setup file for FutureSQL v2.0
# See the file 'futuresql_setup.pl' for documentation.
#############################################################################

%s_spec = (

'action' => {
            'view_custom_list' => {
                            'pre_op'            => sub {
                                                   &check_authorization('intermediate');
                                                   &check_for_qbf;

                                                   },
                            'post_op'           => sub {
                                                   $b_b_id = param('b_b_id');
                                                   $author_select_mode = param('author_select_mode');

                                                   if ( $author_select_mode eq 'edit' )
                                                        {
                                                        $author_action = 'view_custom_record';
                                                        }
                                                   elsif ( $author_select_mode eq 'add_record' )
                                                        {
                                                        $author_action = 'add_record';
                                                        }

                                                   },

                            'field_expressions' => qq~
                                                   1=1 as expression_a_name,
                                                   1=1 as expression_b_name
                                                   ~,

                            'field_expression_names' => qq~
                                                   expression_a_name,
                                                   expression_b_name
                                                   ~,

                            'hard_coded_where_str' => qq~
                                                      ( $key_field > '0' )
                                                      ~,

                            'where_str'            => qq~
                                                      ( $key_field > '0' )
                                                      ~,

                            'order_str'            => qq~
                                                      $key_field desc
                                                      ~,

                            'sub_head'             => qq~ ~,
                            'sub_head_test_field'  => qq~$key_field~,
                            'sub_head_print_field' => qq~$key_field~,

                            'external_table_start' => 'yes',
                            'external_record_text' => 'yes',
                            'external_table_end'   => 'no',

                            'table_start'          => qq~
                                                      custom.authors.view_list_table_start.authors.html
                                                      ~,

                            'record_text'          => qq~
                                                      custom.authors.view_list_record_text.authors.html
                                                      ~,

                            'table_end'            => qq~
                                                      $view_custom_list_table_end
                                                      ~,

                            },

            }

); # end of hash

#############################################################################

1;
