# custom.books.view_list.export.pl
#    Last change:  PFB   4 Feb 2001    3:22 am
#############################################################################
# This is a custom view list spec setup file for FutureSQL v2.0
# See the file 'futuresql_setup.pl' for documentation.
#############################################################################

### relational fields are set up in the main spec file

#############################################################################

%s_spec = (

'action' => {
            'view_custom_list' => {
                            'pre_op'            => sub {
                                                   &check_authorization('public');
                                                   $use_join_str = 'yes';
                                                   &check_for_qbf;

                                                   },
                            'post_op'           => sub {

                                                   },

                            'field_expressions' => qq~
                                                   if(b.book_rating = 'A',
                                                      concat(
                                                             '<b><font color="darkblue">',
                                                             b.book_title,'<br>',
                                                             '</font></b>',
                                                             b.book_description,'<br>',
                                                             b.reader_comments,'<br>',
                                                             '<b><font color="darkred">',
                                                             b.book_rating_label,
                                                             '</font></b>'
                                                            ),
                                                      concat(
                                                             '<b><font color="darkblue">',
                                                             b.book_title,'<br>',
                                                             '</font></b>',
                                                             b.book_description,'<br>',
                                                             b.reader_comments,'<br>',
                                                             '<b>',
                                                             b.book_rating_label,
                                                             '</b>'
                                                            )
                                                     ) as book_field_overview,

                                                   concat('by ', a.first_name, ' ', a.last_name) as author_field_name,

                                                   date_format(b.record_created, '%b %e, %Y') as book_field_date,

                                                   concat('submitted by:<br>',
                                                           r.first_name, ' ', r.last_name) as reader_field_name
                                                   ~,

                            'field_expression_names' => qq~
                                                   book_field_overview,
                                                   author_field_name,
                                                   book_field_date,
                                                   reader_field_name
                                                   ~,

                            'hard_coded_where_str' => qq~
                                                      $join_hard_coded_where_string
                                                      ~,

                            'where_str'            => qq~
                                                      $join_where_string
                                                      ~,

                            'order_str'            => qq~
                                                      $join_order_string
                                                      ~,

                            'sub_head'             => qq~ ~,
                            'sub_head_test_field'  => qq~$key_field~,
                            'sub_head_print_field' => qq~$key_field~,

                            'external_table_start' => 'yes',
                            'external_record_text' => 'yes',
                            'external_table_end'   => 'no',

                            'table_start'          => qq~
                                                      custom.books.view_list_table_start.export.html
                                                      ~,

                            'record_text'          => qq~
                                                      custom.books.view_list_record_text.export.html
                                                      ~,

                            'table_end'            => qq~
                                                      $view_custom_list_table_end
                                                      ~,

                            },

            }

); # end of hash

#############################################################################

1;
