#!/usr/bin/perl
#    Last change: PFB 2001-08-20 16:05:23
##########################################################################
# POD Documentation

=head1 PROGRAM NAME - Main URL file for FutureSQL

This file should be installed in your web tree as the
primary 'script' file to be used in url's. However,
we 'require' in the 'real' file, 'fsql_main.cgi',
which should be installed outside of your web tree,
in the 'futuresql' preferences directory.

The rationale behind this is for security. If the web
server ever outputs a cgi file as text, for some unlikely
reason, then the web visitor would only see this file's
content, rather than the actual script.

Is it necessary? Maybe not, but it doesn't hurt.

=cut

#######################################################################################

$main_file  = '/typical_home_directory/futuresql/fsql_main.cgi';

# We specify the SITE AND DATABASE SPECIFIC setup file here, so that different
# applications can make use of the same main file (fsql_main.cgi), which
# contains only generic code. One should never modify fsql_main.cgi, under
# ordinary circumstances. Note that the site specific setup file calls the
# primary setup file, where you can make more changes.

$site_db_file = '/typical_home_directory/futuresql/fsql_site_db.pl';

if ( -e $main_file )
        {
        require $main_file;
        }
else
        {
        print "Content-type: text/html\n\n";
        print qq~
        <p><br>Error!<p>
        Please contact the system admin.
        <p>
        ~;
        exit;
        }

#######################################################################################

